Bug 91222 - lp_test_format regression on CentOS 7
Summary: lp_test_format regression on CentOS 7
Status: RESOLVED FIXED
Alias: None
Product: Mesa
Classification: Unclassified
Component: Mesa core (show other bugs)
Version: git
Hardware: x86-64 (AMD64) Linux (All)
: medium normal
Assignee: mesa-dev
QA Contact: mesa-dev
URL:
Whiteboard:
Keywords: bisected, regression
Depends on:
Blocks:
 
Reported: 2015-07-03 21:39 UTC by Vinson Lee
Modified: 2015-07-09 05:54 UTC (History)
4 users (show)

See Also:
i915 platform:
i915 features:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Vinson Lee 2015-07-03 21:39:46 UTC
mesa: 83984f134b4a1e2829cb238c404bc82c98be6082 (master 10.7.0-devel)
llvm: llvm-3.4.2-7.el7.x86_64

$ ./build/linux-x86_64-debug/bin/lp_test_format
couldn't open libtxc_dxtn.so, software DXTn compression/decompression unavailable
Testing PIPE_FORMAT_B8G8R8A8_UNORM (float) ...
Testing PIPE_FORMAT_B8G8R8A8_UNORM (unorm8) ...
Testing PIPE_FORMAT_B8G8R8X8_UNORM (float) ...
Testing PIPE_FORMAT_B8G8R8X8_UNORM (unorm8) ...
Testing PIPE_FORMAT_A8R8G8B8_UNORM (float) ...
Testing PIPE_FORMAT_A8R8G8B8_UNORM (unorm8) ...
Testing PIPE_FORMAT_X8R8G8B8_UNORM (float) ...
Testing PIPE_FORMAT_X8R8G8B8_UNORM (unorm8) ...
Testing PIPE_FORMAT_B5G5R5A1_UNORM (float) ...
Testing PIPE_FORMAT_B5G5R5A1_UNORM (unorm8) ...
Testing PIPE_FORMAT_B4G4R4A4_UNORM (float) ...
Testing PIPE_FORMAT_B4G4R4A4_UNORM (unorm8) ...
Testing PIPE_FORMAT_B5G6R5_UNORM (float) ...
Testing PIPE_FORMAT_B5G6R5_UNORM (unorm8) ...
Testing PIPE_FORMAT_R10G10B10A2_UNORM (float) ...
Testing PIPE_FORMAT_R10G10B10A2_UNORM (unorm8) ...
Testing PIPE_FORMAT_L8_UNORM (float) ...
Testing PIPE_FORMAT_L8_UNORM (unorm8) ...
Testing PIPE_FORMAT_A8_UNORM (float) ...
Testing PIPE_FORMAT_A8_UNORM (unorm8) ...
Testing PIPE_FORMAT_I8_UNORM (float) ...
Testing PIPE_FORMAT_I8_UNORM (unorm8) ...
Testing PIPE_FORMAT_L8A8_UNORM (float) ...
Testing PIPE_FORMAT_L8A8_UNORM (unorm8) ...
Testing PIPE_FORMAT_L16_UNORM (float) ...
Testing PIPE_FORMAT_L16_UNORM (unorm8) ...
Testing PIPE_FORMAT_UYVY (float) ...
Testing PIPE_FORMAT_UYVY (unorm8) ...
Testing PIPE_FORMAT_YUYV (float) ...
Testing PIPE_FORMAT_YUYV (unorm8) ...
Testing PIPE_FORMAT_R32_FLOAT (float) ...
Testing PIPE_FORMAT_R32_FLOAT (unorm8) ...
Testing PIPE_FORMAT_R32G32_FLOAT (float) ...
Testing PIPE_FORMAT_R32G32_FLOAT (unorm8) ...
Testing PIPE_FORMAT_R32G32B32_FLOAT (float) ...
Testing PIPE_FORMAT_R32G32B32_FLOAT (unorm8) ...
Testing PIPE_FORMAT_R32G32B32A32_FLOAT (float) ...
Testing PIPE_FORMAT_R32G32B32A32_FLOAT (unorm8) ...
Testing PIPE_FORMAT_R32_UNORM (float) ...
Testing PIPE_FORMAT_R32_UNORM (unorm8) ...
Testing PIPE_FORMAT_R32G32_UNORM (float) ...
Testing PIPE_FORMAT_R32G32_UNORM (unorm8) ...
Testing PIPE_FORMAT_R32G32B32_UNORM (float) ...
Testing PIPE_FORMAT_R32G32B32_UNORM (unorm8) ...
Testing PIPE_FORMAT_R32G32B32A32_UNORM (float) ...
Testing PIPE_FORMAT_R32G32B32A32_UNORM (unorm8) ...
Testing PIPE_FORMAT_R32_USCALED (float) ...
Testing PIPE_FORMAT_R32_USCALED (unorm8) ...
Testing PIPE_FORMAT_R32G32_USCALED (float) ...
Testing PIPE_FORMAT_R32G32_USCALED (unorm8) ...
Testing PIPE_FORMAT_R32G32B32_USCALED (float) ...
Testing PIPE_FORMAT_R32G32B32_USCALED (unorm8) ...
Testing PIPE_FORMAT_R32G32B32A32_USCALED (float) ...
Testing PIPE_FORMAT_R32G32B32A32_USCALED (unorm8) ...
Testing PIPE_FORMAT_R32_SNORM (float) ...
Testing PIPE_FORMAT_R32_SNORM (unorm8) ...
Testing PIPE_FORMAT_R32G32_SNORM (float) ...
Testing PIPE_FORMAT_R32G32_SNORM (unorm8) ...
Testing PIPE_FORMAT_R32G32B32_SNORM (float) ...
Testing PIPE_FORMAT_R32G32B32_SNORM (unorm8) ...
Testing PIPE_FORMAT_R32G32B32A32_SNORM (float) ...
Testing PIPE_FORMAT_R32G32B32A32_SNORM (unorm8) ...
Testing PIPE_FORMAT_R32_SSCALED (float) ...
Testing PIPE_FORMAT_R32_SSCALED (unorm8) ...
Testing PIPE_FORMAT_R32G32_SSCALED (float) ...
Testing PIPE_FORMAT_R32G32_SSCALED (unorm8) ...
Testing PIPE_FORMAT_R32G32B32_SSCALED (float) ...
Testing PIPE_FORMAT_R32G32B32_SSCALED (unorm8) ...
Testing PIPE_FORMAT_R32G32B32A32_SSCALED (float) ...
Testing PIPE_FORMAT_R32G32B32A32_SSCALED (unorm8) ...
Testing PIPE_FORMAT_R16_UNORM (float) ...
Testing PIPE_FORMAT_R16_UNORM (unorm8) ...
Testing PIPE_FORMAT_R16G16_UNORM (float) ...
Testing PIPE_FORMAT_R16G16_UNORM (unorm8) ...
Testing PIPE_FORMAT_R16G16B16_UNORM (float) ...
Testing PIPE_FORMAT_R16G16B16_UNORM (unorm8) ...
Testing PIPE_FORMAT_R16G16B16A16_UNORM (float) ...
Testing PIPE_FORMAT_R16G16B16A16_UNORM (unorm8) ...
Testing PIPE_FORMAT_R16_USCALED (float) ...
Testing PIPE_FORMAT_R16_USCALED (unorm8) ...
Testing PIPE_FORMAT_R16G16_USCALED (float) ...
Testing PIPE_FORMAT_R16G16_USCALED (unorm8) ...
Testing PIPE_FORMAT_R16G16B16_USCALED (float) ...
Both operands to a binary operator are not of the same type!
  %10 = and <4 x i16> %7, <4 x i32> %9
Both operands to a binary operator are not of the same type!
  %12 = and <4 x i16> <i16 1, i16 1, i16 1, i16 1>, <4 x i32> %11
Broken module found, verification continues.

define void @fetch_r16g16b16_uscaled_unorm8(<4 x i8>*, i8*, i32, i32) {
entry:
  %4 = getelementptr i8* %1, i32 0
  %5 = bitcast i8* %4 to <3 x i16>*
  %6 = load <3 x i16>* %5, align 2
  %7 = shufflevector <3 x i16> %6, <3 x i16> undef, <4 x i32> <i32 0, i32 1, i32 2, i32 3>
  %8 = icmp ult <4 x i16> %7, <i16 1, i16 1, i16 1, i16 1>
  %9 = sext <4 x i1> %8 to <4 x i32>
  %10 = and <4 x i16> %7, <4 x i32> %9
  %11 = xor <4 x i32> %9, <i32 -1, i32 -1, i32 -1, i32 -1>
  %12 = and <4 x i16> <i16 1, i16 1, i16 1, i16 1>, <4 x i32> %11
  %13 = or <4 x i16> %10, %12
  %14 = shufflevector <4 x i16> %13, <4 x i16> %13, <2 x i32> <i32 0, i32 1>
  %15 = shufflevector <4 x i16> %13, <4 x i16> %13, <2 x i32> <i32 2, i32 3>
  %16 = bitcast <2 x i16> %14 to <4 x i8>
  %17 = bitcast <2 x i16> %15 to <4 x i8>
  %18 = shufflevector <4 x i8> %16, <4 x i8> %17, <4 x i32> <i32 0, i32 2, i32 4, i32 6>
  %19 = sub <4 x i8> zeroinitializer, %18
  %20 = bitcast <4 x i8> %19 to i32
  %21 = and i32 %20, 16777215
  %22 = or i32 bitcast (<4 x i8> <i8 0, i8 0, i8 0, i8 -1> to i32), %21
  %23 = bitcast i32 %22 to <4 x i8>
  store <4 x i8> %23, <4 x i8>* %0
  ret void
}

src/gallium/auxiliary/gallivm/lp_bld_init.c:496:gallivm_verify_function: Assertion `0' failed.
Trace/breakpoint trap (core dumped)

(gdb) bt
#0  0x000000000042fb24 in _debug_assert_fail (expr=0xd7c7ad "0", 
    file=0xd7c710 "src/gallium/auxiliary/gallivm/lp_bld_init.c", line=496, 
    function=0xd7c880 <__func__.8169> "gallivm_verify_function") at src/gallium/auxiliary/util/u_debug.c:309
#1  0x000000000047b3d7 in gallivm_verify_function (gallivm=0x192b820, func=0x1993990)
    at src/gallium/auxiliary/gallivm/lp_bld_init.c:496
#2  0x000000000042cbe3 in add_fetch_rgba_test (gallivm=0x192b820, verbose=0, 
    desc=0x1337140 <util_format_r16g16b16_uscaled_description>, type=...)
    at src/gallium/drivers/llvmpipe/lp_test_format.c:122
#3  0x000000000042d0fc in test_format_unorm8 (verbose=0, fp=0x0, desc=0x1337140 <util_format_r16g16b16_uscaled_description>)
    at src/gallium/drivers/llvmpipe/lp_test_format.c:235
#4  0x000000000042d4dc in test_one (verbose=0, fp=0x0, format_desc=0x1337140 <util_format_r16g16b16_uscaled_description>)
    at src/gallium/drivers/llvmpipe/lp_test_format.c:321
#5  0x000000000042d56e in test_all (verbose=0, fp=0x0) at src/gallium/drivers/llvmpipe/lp_test_format.c:362
#6  0x000000000042d5ad in test_some (verbose=0, fp=0x0, n=1000) at src/gallium/drivers/llvmpipe/lp_test_format.c:375
#7  0x000000000042e5ee in main (argc=1, argv=0x7fffb4138358) at src/gallium/drivers/llvmpipe/lp_test_main.c:410

e35c5717837d9ac6d9722b011852bdf187f29776 is the first bad commit
commit e35c5717837d9ac6d9722b011852bdf187f29776
Author: Dave Airlie <airlied@gmail.com>
Date:   Sat Jun 27 14:21:54 2015 +1000

    gallivm: add fp64 support. (v2.1)
    
    This adds support for ARB_gpu_shader_fp64 and ARB_vertex_attrib_64bit to
    llvmpipe.
    
    Two things that don't mix well are SoA and doubles, see
    emit_fetch_double, and emit_store_double_chan in this.
    
    I've also had to split emit_data.chan, to add src_chan,
    which can be different for doubles.
    
    It handles indirect double fetches from temps, inputs, constants
    and immediates. It doesn't handle double stores to indirects,
    however it appears the mesa/st doesn't currently emit these,
    it always does UARL/MOV combos, which will work fine.
    
    tested with piglit, no regressions, all the fp64 tests seem to pass.
    
    v2:
    switch to using shuffles for fetch/store (Roland)
    assert on indirect double stores - mesa/st never emits these (it uses MOV)
    fix indirect temp/input/constant/immediates (Roland)
    typos/formatting fixes (Roland)
    
    v2.1:
    cleanup some long lines, emit_store_double_chan cleanups.
    
    Reviewed-by: Roland Scheidegger <sroland@vmware.com>
    Signed-off-by: Dave Airlie <airlied@redhat.com>

:040000 040000 98d18647954e2dee3c72bd7be905fb43c4ae325f 5acc6b73cb76548f166f1dd779fabb186c55d8e6 M	src
bisect run success


bug/show.html.tmpl processed on Mar 27, 2017 at 08:34:43.
(provided by the Example extension).